DrawMesh
Date: 2019-10-22

org.jmol.shapespecial

## Class DrawMesh

- java.lang.Object
- - org.jmol.util.MeshSurface
  - - org.jmol.shape.Mesh
    - - org.jmol.shapespecial.DrawMesh

- Direct Known Subclasses:
    CGOMesh

      public class DrawMesh
      extends Mesh

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `(package private) javajs.util.V3[]` | `axes`
    `(package private) javajs.util.V3` | `axis`
    `javajs.util.BS` | `bsMeshesVisible`
    `float` | `drawArrowScale`
    `Draw.EnumDrawType` | `drawType`
    `(package private) Draw.EnumDrawType[]` | `drawTypes`
    `(package private) int` | `drawVertexCount`
    `(package private) int[]` | `drawVertexCounts`
    `boolean` | `isBarb`
    `(package private) boolean` | `isFixed`
    `boolean` | `isScaleSet`
    `boolean` | `isVector`
    `javajs.util.BS` | `modelFlags`
    `boolean` | `noHead`
    `(package private) javajs.util.P3[]` | `ptCenters`
    `float` | `scale`

    - ### Fields inherited from class org.jmol.shape.Mesh

      `atomIndex, bsTemp, cappingObject, checkByteCount, color, colorCommand, colorDensity, colorType, connectedAtoms, diameter, drawTriangles, fillTriangles, frontOnly, havePlanarContours, haveXyPoints, index, insideOut, isModelConnected, isShell, isTwoSided, isValid, lattice, lighting, lineData, linkedMesh, meshColix, modelIndex, normixes, PREVIOUS_MESH_ID, ptCenter, recalcAltVertices, scale3d, scriptCommand, showContourLines, showPoints, showTriangles, slabbingObject, symopColixes, symopNormixes, symops, thisID, title, unitCell, useColix, vAB, vertexColorMap, visibilityFlags, visible, volumeRenderPointSize, vTemp, width`

    - ### Fields inherited from class org.jmol.util.MeshSurface

      `altVertices, bsDisplay, bsPolygons, bsSlabDisplay, bsSlabGhost, colix, colixBack, colorsExplicit, dataOnly, haveQuads, iA, iB, iC, isColorSolid, isDrawPolygon, isMerged, mat4, mergePolygonCount0, mergeVertexCount0, meshType, normalCount, normals, normalsTemp, normixCount, nSets, oabc, offset, P_CHECK, P_CONTOUR, P_EXPLICIT_COLOR, pc, pcs, pis, polygonCount0, SEED_COUNT, slabColix, slabMeshType, slabOptions, surfaceAtoms, surfaceSet, vc, vcs, vertexCount0, vertexSets, vertexSource, vs, vvs, vwr`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DrawMesh(Viewer vwr, java.lang.String thisID, short colix, int index)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `clear(java.lang.String meshType)`
    `void` | `deleteAtoms(int modelIndex)`
    `boolean` | `isRenderScalable()`
    `(package private) void` | `offset(javajs.util.V3 offset)`
    `(package private) void` | `setCenter(int iModel)`
    `(package private) void` | `setCenters()`

    - ### Methods inherited from class org.jmol.shape.Mesh

      `checkWithin, clearMesh, getBoundingBox, getMinDistance2ForVertexGrouping, getNormals, getNormalsTemp, getOffsetVertices, getRendering, getState, getUnitCell, getVertexIndexFromNumber, getVisibleVBS, getVisibleVertexBitSet, initialize, mesh1, rotateTranslate, setLighting, setNormixes, setShowWithin, setTokenProperty, setTranslucent, setVisibilityFlags, sumVertexNormals, sumVertexNormals2`

    - ### Methods inherited from class org.jmol.util.MeshSurface

      `addPolygon, addPolygonC, addQuad, addTriangle, addTriangleCheck, addV, addVCVal, getFaces, getMeshSlicer, getResolution, getSlabColor, getSlabType, getSphereData, getSphericalInterpolationFraction, getVertices, invalidatePolygons, newMesh, resetSlab, setABC, setBoundingBox, setBox, setColix, setColixBack, setPolygonCount, setTranslucentVertices, slabBrillouin, slabPolygonsList`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### bsMeshesVisible

          public javajs.util.BS bsMeshesVisible

    - #### modelFlags

          public javajs.util.BS modelFlags

    - #### drawType

          public Draw.EnumDrawType drawType

    - #### drawTypes

          Draw.EnumDrawType[] drawTypes

    - #### ptCenters

          javajs.util.P3[] ptCenters

    - #### axis

          javajs.util.V3 axis

    - #### axes

          javajs.util.V3[] axes

    - #### drawVertexCount

          int drawVertexCount

    - #### drawVertexCounts

          int[] drawVertexCounts

    - #### isFixed

          boolean isFixed

    - #### isVector

          public boolean isVector

    - #### drawArrowScale

          public float drawArrowScale

    - #### noHead

          public boolean noHead

    - #### isBarb

          public boolean isBarb

    - #### scale

          public float scale

    - #### isScaleSet

          public boolean isScaleSet

  - ### Constructor Detail

    - #### DrawMesh

          public DrawMesh(Viewer vwr,
                          java.lang.String thisID,
                          short colix,
                          int index)

      Parameters:
        `vwr` -
        `thisID` -
        `colix` -
        `index` -

  - ### Method Detail

    - #### clear

          public void clear(java.lang.String meshType)

      Overrides:
        `clear` in class `Mesh`

    - #### setCenters

          void setCenters()

    - #### setCenter

          final void setCenter(int iModel)

    - #### offset

          void offset(javajs.util.V3 offset)

    - #### deleteAtoms

          public void deleteAtoms(int modelIndex)

    - #### isRenderScalable

          public boolean isRenderScalable()